/*****************************************************************************
|*
|*  File:      phytec.h
|*
|*  Version:    1.3
|* 
|*  Copyright 2001-2002 Altium BV
|*
 ****************************************************************************/

#ifndef _PHYTEC_H
#define _PHYTEC_H

extern _xdat volatile unsigned char CONTROL1 _AT(0xFC00);    /* Controlregister 1 */
extern _xdat volatile unsigned char CONTROL2 _AT(0xFC01);    /* Controlregister 2 */
extern _xdat volatile unsigned char ADDRESS  _AT(0xFC02);    /* Address register */
extern _xdat volatile unsigned char MASK        _AT(0xFC03);    /* Mask register */

/* 
 * The following inline function initializes the MMU.
 */
_inline void 
phytec_mmu_init( void )
{
    /* initialize MMU */
    ADDRESS = 0x80;          /* HA15=1 */
# ifdef PHYTEC_MMU_V2    /* T89C51CC01 has MMU version 2*/
    MASK = 0x70;                /* mask MA12 - MA14 */
    CONTROL1 = 0x48;         /* VN-EN=1, enable Von Neumann mem. FA16=1, bank 1 (bank 0 = flash-tools) */
# else
    MASK = 0x7C;               /* mask MA10 - MA14 */
    CONTROL1 = 0x12;        /* VN-EN=1, enable Von Neumann mem. FA16=1, bank 1 (bank 0 = flash-tools) */
# endif
    /* so now 0x8000-FFFF = Harvard, 0000-7fff = Von Neumann. */
}
#endif /* _PHYTEC_H */
